]> git.lizzy.rs Git - LightOverlay.git/commitdiff
Updated mod to Minecraft 1.19.3 (#163)
authorStefan K <1214548+Krunch@users.noreply.github.com>
Thu, 29 Dec 2022 16:11:54 +0000 (11:11 -0500)
committerGitHub <noreply@github.com>
Thu, 29 Dec 2022 16:11:54 +0000 (00:11 +0800)
Updated to Gradle 7.6
Updated to Loom 1.0

18 files changed:
build.gradle
common/src/main/java/me/shedaniel/lightoverlay/common/LightOverlayRenderer.java
common/src/main/java/me/shedaniel/lightoverlay/common/LightOverlayTicker.java
fabric/src/main/java/me/shedaniel/lightoverlay/common/fabric/LightOverlayTickerImpl.java
fabric/src/main/java/me/shedaniel/lightoverlay/fabric/FrustumHelper.java [deleted file]
fabric/src/main/java/me/shedaniel/lightoverlay/fabric/LightOverlayImpl.java
fabric/src/main/resources/fabric.mod.json
fabric/src/main/resources/lightoverlay.accesswidener
forge/src/main/java/me/shedaniel/lightoverlay/common/forge/LightOverlayTickerImpl.java
forge/src/main/java/me/shedaniel/lightoverlay/forge/FrustumHelper.java [deleted file]
forge/src/main/java/me/shedaniel/lightoverlay/forge/LightOverlayImpl.java
forge/src/main/resources/META-INF/accesstransformer.cfg
forge/src/main/resources/META-INF/mods.toml
gradle.properties
gradle/wrapper/gradle-wrapper.jar
gradle/wrapper/gradle-wrapper.properties
gradlew
gradlew.bat

index ef30ab796e302a8e9a46f22dfb3a19117b92ee68..3f1aa9b6326612bcd26e193add8e081100f31c67 100644 (file)
@@ -1,6 +1,6 @@
 plugins {
     id "architectury-plugin" version "3.4-SNAPSHOT"
-    id "dev.architectury.loom" version "0.12.0-SNAPSHOT" apply false
+    id "dev.architectury.loom" version "1.0-SNAPSHOT" apply false
 }
 
 architectury {
index 9505cb98adede282cf04992cb5b5676a4f77bb39..09d75a8395270cb9e0dd766fdec969516cab31a2 100644 (file)
@@ -1,11 +1,7 @@
 package me.shedaniel.lightoverlay.common;
 
-import com.google.common.base.Suppliers;
 import com.mojang.blaze3d.systems.RenderSystem;
 import com.mojang.blaze3d.vertex.*;
-import com.mojang.math.Matrix4f;
-import com.mojang.math.Vector3f;
-import dev.architectury.injectables.targets.ArchitecturyTarget;
 import it.unimi.dsi.fastutil.longs.Long2ByteMap;
 import net.minecraft.client.Camera;
 import net.minecraft.client.Minecraft;
@@ -18,15 +14,14 @@ import net.minecraft.core.BlockPos;
 import net.minecraft.core.Direction;
 import net.minecraft.util.Mth;
 import net.minecraft.world.level.Level;
+import net.minecraft.world.phys.AABB;
 import net.minecraft.world.phys.shapes.CollisionContext;
 import net.minecraft.world.phys.shapes.VoxelShape;
+import org.joml.Matrix4f;
+import org.joml.Quaternionf;
 
-import java.lang.invoke.MethodHandle;
-import java.lang.invoke.MethodHandles;
-import java.lang.invoke.MethodType;
 import java.util.Map;
 import java.util.function.Consumer;
-import java.util.function.Supplier;
 
 public class LightOverlayRenderer implements Consumer<PoseStack> {
     private final Minecraft minecraft = Minecraft.getInstance();
@@ -93,7 +88,7 @@ public class LightOverlayRenderer implements Consumer<PoseStack> {
         double cameraZ = camera.getPosition().z;
         poses.pushPose();
         poses.translate(pos.getX() + 0.5 - cameraX, pos.getY() - cameraY + 0.005, pos.getZ() + 0.5 - cameraZ);
-        poses.mulPose(Vector3f.XP.rotationDegrees(90));
+        poses.mulPose(new Quaternionf().fromAxisAngleDeg(1, 0, 0, 90));
 //        poses.glNormal3f(0.0F, 1.0F, 0.0F);
         float size = 0.07F;
         poses.scale(-size, -size, size);
@@ -112,7 +107,7 @@ public class LightOverlayRenderer implements Consumer<PoseStack> {
         BufferBuilder builder = tesselator.getBuilder();
         builder.begin(VertexFormat.Mode.DEBUG_LINES, DefaultVertexFormat.POSITION_COLOR);
         BlockPos.MutableBlockPos mutable = new BlockPos.MutableBlockPos();
-    
+        
         for (Map.Entry<CubicChunkPos, Long2ByteMap> entry : ticker.CHUNK_MAP.entrySet()) {
             CubicChunkPos chunkPos = entry.getKey();
             if (LightOverlay.caching && (Mth.abs(chunkPos.x - playerPosX) > chunkRange || Mth.abs(chunkPos.y - playerPosY) > Math.max(1, chunkRange >> 1) || Mth.abs(chunkPos.z - playerPosZ) > chunkRange)) {
@@ -163,20 +158,7 @@ public class LightOverlayRenderer implements Consumer<PoseStack> {
         builder.vertex(x + .01, y, z + .99).color(red, green, blue, 255).endVertex();
     }
     
-    private static final Supplier<MethodHandle> IS_FRUSTUM_VISIBLE = Suppliers.memoize(() -> {
-        try {
-            return MethodHandles.lookup().findStatic(Class.forName("me.shedaniel.lightoverlay." + ArchitecturyTarget.getCurrentTarget() + ".LightOverlayImpl"), "isFrustumVisible",
-                    MethodType.methodType(boolean.class, Frustum.class, double.class, double.class, double.class, double.class, double.class, double.class));
-        } catch (NoSuchMethodException | IllegalAccessException | ClassNotFoundException e) {
-            throw new RuntimeException(e);
-        }
-    });
-    
     public boolean isFrustumVisible(double minX, double minY, double minZ, double maxX, double maxY, double maxZ) {
-        try {
-            return frustum == null || (boolean) IS_FRUSTUM_VISIBLE.get().invokeExact(frustum, minX, minY, minZ, maxX, maxY, maxZ);
-        } catch (Throwable throwable) {
-            throw new RuntimeException(throwable);
-        }
+        return frustum.isVisible(new AABB(minX, minY, minZ, maxX, maxY, maxZ));
     }
 }
index a2539eccaee65dbcc92b4ce340d0609a12ab6774..d517b8538407e0a5959ba3f1002627dfb49269ae 100644 (file)
@@ -19,7 +19,6 @@ import net.minecraft.world.level.BlockGetter;
 import net.minecraft.world.level.Level;
 import net.minecraft.world.level.LightLayer;
 import net.minecraft.world.level.biome.Biome;
-import net.minecraft.world.level.biome.Biomes;
 import net.minecraft.world.level.block.Block;
 import net.minecraft.world.level.block.state.BlockState;
 import net.minecraft.world.level.chunk.ChunkStatus;
index 4d037c33d4ba83aa5a58e3dd07c1799a77bf65ca..6ab7b1b0fd8adee77aa2df5f26b4227512011ecf 100644 (file)
@@ -2,7 +2,7 @@ package me.shedaniel.lightoverlay.common.fabric;
 
 import com.google.common.collect.ImmutableSet;
 import net.minecraft.core.Holder;
-import net.minecraft.core.Registry;
+import net.minecraft.core.registries.Registries;
 import net.minecraft.resources.ResourceLocation;
 import net.minecraft.tags.TagKey;
 import net.minecraft.world.entity.Entity;
@@ -13,7 +13,7 @@ import net.minecraft.world.level.biome.Biome;
 import net.minecraft.world.level.biome.Biomes;
 
 public class LightOverlayTickerImpl {
-    private static final TagKey<Biome> MUSHROOM = TagKey.create(Registry.BIOME_REGISTRY, new ResourceLocation("c", "mushroom"));
+    private static final TagKey<Biome> MUSHROOM = TagKey.create(Registries.BIOME, new ResourceLocation("c", "mushroom"));
     
     public static void populateEntityType(EntityType<Entity> type) {
         type.factory = (entityType, level) -> null;
diff --git a/fabric/src/main/java/me/shedaniel/lightoverlay/fabric/FrustumHelper.java b/fabric/src/main/java/me/shedaniel/lightoverlay/fabric/FrustumHelper.java
deleted file mode 100644 (file)
index ee36fdc..0000000
+++ /dev/null
@@ -1,31 +0,0 @@
-package me.shedaniel.lightoverlay.fabric;
-
-import com.mojang.math.Vector4f;
-import net.minecraft.client.renderer.culling.Frustum;
-
-public class FrustumHelper {
-    public static boolean isVisible(Frustum frustum, double minX, double minY, double minZ, double maxX, double maxY, double maxZ) {
-        float x1 = (float) (minX - frustum.camX);
-        float y1 = (float) (minY - frustum.camY);
-        float z1 = (float) (minZ - frustum.camZ);
-        float x2 = (float) (maxX - frustum.camX);
-        float y2 = (float) (maxY - frustum.camY);
-        float z2 = (float) (maxZ - frustum.camZ);
-        return isAnyCornerVisible(frustum, x1, y1, z1, x2, y2, z2);
-    }
-    
-    private static boolean isAnyCornerVisible(Frustum frustum, float x1, float y1, float z1, float x2, float y2, float z2) {
-        Vector4f[] homogeneousCoordinates = frustum.frustumData;
-        for (Vector4f vector4f : homogeneousCoordinates) {
-            if (dotProduct(vector4f, x1, y1, z1, 1.0F) <= 0.0F && dotProduct(vector4f, x2, y1, z1, 1.0F) <= 0.0F && dotProduct(vector4f, x1, y2, z1, 1.0F) <= 0.0F && dotProduct(vector4f, x2, y2, z1, 1.0F) <= 0.0F && dotProduct(vector4f, x1, y1, z2, 1.0F) <= 0.0F && dotProduct(vector4f, x2, y1, z2, 1.0F) <= 0.0F && dotProduct(vector4f, x1, y2, z2, 1.0F) <= 0.0F && dotProduct(vector4f, x2, y2, z2, 1.0F) <= 0.0F) {
-                return false;
-            }
-        }
-        
-        return true;
-    }
-    
-    private static float dotProduct(Vector4f self, float x, float y, float z, float w) {
-        return self.x() * x + self.y() * y + self.z() * z + self.w() * w;
-    }
-}
index 58cd0f7934bc5d2144274d2d398a980f7dfb0f19..c73c7f877fd560386272e7afab9c99fe5ab97014 100644 (file)
@@ -3,7 +3,6 @@ package me.shedaniel.lightoverlay.fabric;
 import com.mojang.blaze3d.vertex.PoseStack;
 import me.shedaniel.lightoverlay.common.LightOverlay;
 import net.fabricmc.fabric.api.client.rendering.v1.WorldRenderEvents;
-import net.minecraft.client.renderer.culling.Frustum;
 
 import java.util.function.Consumer;
 
@@ -15,8 +14,4 @@ public class LightOverlayImpl {
         WorldRenderEvents.AFTER_SETUP.register(context -> LightOverlay.renderer.frustum = context.frustum());
         WorldRenderEvents.BEFORE_DEBUG_RENDER.register(context -> debugRenderer.accept(context.matrixStack()));
     }
-    
-    public static boolean isFrustumVisible(Frustum frustum, double minX, double minY, double minZ, double maxX, double maxY, double maxZ) {
-        return FrustumHelper.isVisible(frustum, minX, minY, minZ, maxX, maxY, maxZ);
-    }
 }
index 504209aad634db9cbc02f9cc957565c4b499f295..24b75f28b865a4431817f1f77692cf65d05d2160 100755 (executable)
     "lightoverlay.mixins.json"
   ],
   "accessWidener": "lightoverlay.accesswidener",
-  "custom": {
-    "modmenu:clientsideOnly": true
-  },
   "depends": {
-    "fabric": ">=0.29.1",
-    "architectury": ">=2-",
-    "cloth-config2": ">=5-"
+    "fabricloader": ">=0.14.11",
+    "fabric-api": "*",
+    "minecraft": "~1.19.3",
+    "java": ">=17",
+    "architectury": ">=7-",
+    "cloth-config2": ">=9-"
   }
 }
index 06097972e13e5eb3099ab8a368a2f66b0848b76d..d507626f707eadb353d2c827e23c2f39cf945835 100644 (file)
@@ -1,9 +1,5 @@
 accessWidener  v1  named
 accessible field net/minecraft/network/protocol/game/ClientboundSectionBlocksUpdatePacket sectionPos Lnet/minecraft/core/SectionPos;
-accessible field net/minecraft/client/renderer/culling/Frustum camX D
-accessible field net/minecraft/client/renderer/culling/Frustum camY D
-accessible field net/minecraft/client/renderer/culling/Frustum camZ D
-accessible field net/minecraft/client/renderer/culling/Frustum frustumData [Lcom/mojang/math/Vector4f;
 accessible field net/minecraft/world/entity/EntityType factory Lnet/minecraft/world/entity/EntityType$EntityFactory;
 accessible field net/minecraft/world/entity/EntityType category Lnet/minecraft/world/entity/MobCategory;
 accessible field net/minecraft/world/entity/EntityType immuneTo Lcom/google/common/collect/ImmutableSet;
index 3bb038cd84e009b6245a6513c2e1388376133404..47a9763cb7a0a485738dda9cf2a5253f3122788f 100644 (file)
@@ -1,15 +1,14 @@
 package me.shedaniel.lightoverlay.common.forge;
 
 import net.minecraft.core.Holder;
-import net.minecraft.core.Registry;
+import net.minecraft.core.registries.Registries;
 import net.minecraft.resources.ResourceLocation;
 import net.minecraft.tags.TagKey;
 import net.minecraft.world.level.biome.Biome;
 import net.minecraft.world.level.biome.Biomes;
-import net.minecraftforge.common.data.ForgeBiomeTagsProvider;
 
 public class LightOverlayTickerImpl {
-    private static final TagKey<Biome> MUSHROOM = TagKey.create(Registry.BIOME_REGISTRY, new ResourceLocation("forge", "is_mushroom"));
+    private static final TagKey<Biome> MUSHROOM = TagKey.create(Registries.BIOME, new ResourceLocation("forge", "is_mushroom"));
     
     public static boolean isMushroom(Holder<Biome> biome) {
         return biome.is(Biomes.MUSHROOM_FIELDS) || biome.is(MUSHROOM);
diff --git a/forge/src/main/java/me/shedaniel/lightoverlay/forge/FrustumHelper.java b/forge/src/main/java/me/shedaniel/lightoverlay/forge/FrustumHelper.java
deleted file mode 100644 (file)
index 46acc0b..0000000
+++ /dev/null
@@ -1,31 +0,0 @@
-package me.shedaniel.lightoverlay.forge;
-
-import com.mojang.math.Vector4f;
-import net.minecraft.client.renderer.culling.Frustum;
-
-public class FrustumHelper {
-    public static boolean isVisible(Frustum frustum, double minX, double minY, double minZ, double maxX, double maxY, double maxZ) {
-        float x1 = (float) (minX - frustum.camX);
-        float y1 = (float) (minY - frustum.camY);
-        float z1 = (float) (minZ - frustum.camZ);
-        float x2 = (float) (maxX - frustum.camX);
-        float y2 = (float) (maxY - frustum.camY);
-        float z2 = (float) (maxZ - frustum.camZ);
-        return isAnyCornerVisible(frustum, x1, y1, z1, x2, y2, z2);
-    }
-    
-    private static boolean isAnyCornerVisible(Frustum frustum, float x1, float y1, float z1, float x2, float y2, float z2) {
-        Vector4f[] homogeneousCoordinates = frustum.frustumData;
-        for (Vector4f vector4f : homogeneousCoordinates) {
-            if (dotProduct(vector4f, x1, y1, z1, 1.0F) <= 0.0F && dotProduct(vector4f, x2, y1, z1, 1.0F) <= 0.0F && dotProduct(vector4f, x1, y2, z1, 1.0F) <= 0.0F && dotProduct(vector4f, x2, y2, z1, 1.0F) <= 0.0F && dotProduct(vector4f, x1, y1, z2, 1.0F) <= 0.0F && dotProduct(vector4f, x2, y1, z2, 1.0F) <= 0.0F && dotProduct(vector4f, x1, y2, z2, 1.0F) <= 0.0F && dotProduct(vector4f, x2, y2, z2, 1.0F) <= 0.0F) {
-                return false;
-            }
-        }
-        
-        return true;
-    }
-    
-    private static float dotProduct(Vector4f self, float x, float y, float z, float w) {
-        return self.x() * x + self.y() * y + self.z() * z + self.w() * w;
-    }
-}
index f9ac6ef87cd986b972021fdaa28a48d5f3c36ab3..517d2c6428f5391ed3df1d631aba5c9e4b21d39e 100644 (file)
@@ -3,7 +3,6 @@ package me.shedaniel.lightoverlay.forge;
 import com.mojang.blaze3d.vertex.PoseStack;
 import me.shedaniel.lightoverlay.common.LightOverlay;
 import me.shedaniel.lightoverlay.common.LightOverlayRenderer;
-import net.minecraft.client.renderer.culling.Frustum;
 import net.minecraftforge.api.distmarker.Dist;
 import net.minecraftforge.fml.DistExecutor;
 
@@ -24,10 +23,6 @@ public class LightOverlayImpl {
         }
     }
     
-    public static boolean isFrustumVisible(Frustum clippingHelper, double v, double v1, double v2, double v3, double v4, double v5) {
-        return FrustumHelper.isVisible(clippingHelper, v, v1, v2, v3, v4, v5);
-    }
-    
     public static void renderWorldLast(PoseStack stack) {
         debugRenderer.accept(stack);
     }
index 6c6bb47fdd650600341ea1bf991df1499b45a955..33764e11c914faa95d093db7e6440a69172f4fd5 100644 (file)
@@ -1,5 +1 @@
-public net.minecraft.client.renderer.culling.Frustum f_112996_ # camX
-public net.minecraft.client.renderer.culling.Frustum f_112997_ # camY
-public net.minecraft.client.renderer.culling.Frustum f_112998_ # camZ
-public net.minecraft.client.renderer.culling.Frustum f_112995_ # frustumData
 public net.minecraft.network.protocol.game.ClientboundSectionBlocksUpdatePacket f_132980_ # sectionPos
\ No newline at end of file
index 5c9020875c3855fbb75082fb7d05a0219e2a9fb3..5ab04b0dd2cf3657ee13e09ab592ed823c7d05d0 100755 (executable)
@@ -1,5 +1,5 @@
 modLoader = "javafml"
-loaderVersion = "[37,)"
+loaderVersion = "[44,)"
 issueTrackerURL = "https://github.com/shedaniel/LightOverlay/issues/" #optional
 logoFile = "icon.png"
 authors = "shedaniel"
@@ -15,20 +15,20 @@ To provide users with NEI-like light overlay.
 [[dependencies.lightoverlay]]
 modId = "cloth_config"
 mandatory = true
-versionRange = "[6,)"
+versionRange = "[9,)"
 ordering = "NONE"
 side = "CLIENT"
 
 [[dependencies.lightoverlay]]
 modId = "architectury"
 mandatory = true
-versionRange = "[3,)"
+versionRange = "[7,)"
 ordering = "NONE"
 side = "CLIENT"
 
 [[dependencies.lightoverlay]]
 modId = "forge"
 mandatory = true
-versionRange = "[41.0.94,)"
+versionRange = "[44.0.37,)"
 ordering = "NONE"
 side = "BOTH"
index c92f33ffe412afa95c2af6fd963b9ecbb4a9f3ba..2899479442c86ab48746c3043769bcc058f42af3 100755 (executable)
@@ -1,16 +1,16 @@
 org.gradle.jvmargs=-Xmx3G
 org.gradle.daemon=false
 
-mod_version=7.0.1
-minecraft_version=1.19
+mod_version=7.0.2
+minecraft_version=1.19.3
 
-architectury_version=5.9.30
+architectury_version=7.0.66
 
 # fabric
-fabric_loader_version=0.14.7
-fabric_api_version=0.55.3+1.19
-cloth_config_version=7.0.73
-modmenu_version=4.0.0
+fabric_loader_version=0.14.12
+fabric_api_version=0.70.0+1.19.3
+cloth_config_version=9.0.94
+modmenu_version=5.0.2
 
 # forge
-forge_version=41.0.94
\ No newline at end of file
+forge_version=44.0.37
\ No newline at end of file
index 7a3265ee94c0ab25cf079ac8ccdf87f41d455d42..943f0cbfa754578e88a3dae77fce6e3dea56edbf 100755 (executable)
Binary files a/gradle/wrapper/gradle-wrapper.jar and b/gradle/wrapper/gradle-wrapper.jar differ
index d8910e13b13e526ca4f1d93c75d4385607a6df14..f398c33c4b08dabb3f1275e57706c2de4effb50c 100755 (executable)
@@ -1,5 +1,6 @@
-distributionUrl=https\://services.gradle.org/distributions/gradle-7.3-all.zip
 distributionBase=GRADLE_USER_HOME
 distributionPath=wrapper/dists
-zipStorePath=wrapper/dists
+distributionUrl=https\://services.gradle.org/distributions/gradle-7.6-bin.zip
+networkTimeout=10000
 zipStoreBase=GRADLE_USER_HOME
+zipStorePath=wrapper/dists
diff --git a/gradlew b/gradlew
index cccdd3d517fc5249beaefa600691cf150f2fa3e6..65dcd68d65c82f2a5338fded4af852f9caf93b93 100755 (executable)
--- a/gradlew
+++ b/gradlew
-#!/usr/bin/env sh
+#!/bin/sh
+
+#
+# Copyright © 2015-2021 the original authors.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#      https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
 
 ##############################################################################
-##
-##  Gradle start up script for UN*X
-##
+#
+#   Gradle start up script for POSIX generated by Gradle.
+#
+#   Important for running:
+#
+#   (1) You need a POSIX-compliant shell to run this script. If your /bin/sh is
+#       noncompliant, but you have some other compliant shell such as ksh or
+#       bash, then to run this script, type that shell name before the whole
+#       command line, like:
+#
+#           ksh Gradle
+#
+#       Busybox and similar reduced shells will NOT work, because this script
+#       requires all of these POSIX shell features:
+#         * functions;
+#         * expansions «$var», «${var}», «${var:-default}», «${var+SET}»,
+#           «${var#prefix}», «${var%suffix}», and «$( cmd )»;
+#         * compound commands having a testable exit status, especially «case»;
+#         * various built-in commands including «command», «set», and «ulimit».
+#
+#   Important for patching:
+#
+#   (2) This script targets any POSIX shell, so it avoids extensions provided
+#       by Bash, Ksh, etc; in particular arrays are avoided.
+#
+#       The "traditional" practice of packing multiple parameters into a
+#       space-separated string is a well documented source of bugs and security
+#       problems, so this is (mostly) avoided, by progressively accumulating
+#       options in "$@", and eventually passing that to Java.
+#
+#       Where the inherited environment variables (DEFAULT_JVM_OPTS, JAVA_OPTS,
+#       and GRADLE_OPTS) rely on word-splitting, this is performed explicitly;
+#       see the in-line comments for details.
+#
+#       There are tweaks for specific operating systems such as AIX, CygWin,
+#       Darwin, MinGW, and NonStop.
+#
+#   (3) This script is generated from the Groovy template
+#       https://github.com/gradle/gradle/blob/HEAD/subprojects/plugins/src/main/resources/org/gradle/api/internal/plugins/unixStartScript.txt
+#       within the Gradle project.
+#
+#       You can find Gradle at https://github.com/gradle/gradle/.
+#
 ##############################################################################
 
 # Attempt to set APP_HOME
+
 # Resolve links: $0 may be a link
-PRG="$0"
-# Need this for relative symlinks.
-while [ -h "$PRG" ] ; do
-    ls=`ls -ld "$PRG"`
-    link=`expr "$ls" : '.*-> \(.*\)$'`
-    if expr "$link" : '/.*' > /dev/null; then
-        PRG="$link"
-    else
-        PRG=`dirname "$PRG"`"/$link"
-    fi
+app_path=$0
+
+# Need this for daisy-chained symlinks.
+while
+    APP_HOME=${app_path%"${app_path##*/}"}  # leaves a trailing /; empty if no leading path
+    [ -h "$app_path" ]
+do
+    ls=$( ls -ld "$app_path" )
+    link=${ls#*' -> '}
+    case $link in             #(
+      /*)   app_path=$link ;; #(
+      *)    app_path=$APP_HOME$link ;;
+    esac
 done
-SAVED="`pwd`"
-cd "`dirname \"$PRG\"`/" >/dev/null
-APP_HOME="`pwd -P`"
-cd "$SAVED" >/dev/null
 
-APP_NAME="Gradle"
-APP_BASE_NAME=`basename "$0"`
+# This is normally unused
+# shellcheck disable=SC2034
+APP_BASE_NAME=${0##*/}
+APP_HOME=$( cd "${APP_HOME:-./}" && pwd -P ) || exit
 
 # Add default JVM options here. You can also use JAVA_OPTS and GRADLE_OPTS to pass JVM options to this script.
-DEFAULT_JVM_OPTS=""
+DEFAULT_JVM_OPTS='"-Xmx64m" "-Xms64m"'
 
 # Use the maximum available, or set MAX_FD != -1 to use that value.
-MAX_FD="maximum"
+MAX_FD=maximum
 
 warn () {
     echo "$*"
-}
+} >&2
 
 die () {
     echo
     echo "$*"
     echo
     exit 1
-}
+} >&2
 
 # OS specific support (must be 'true' or 'false').
 cygwin=false
 msys=false
 darwin=false
 nonstop=false
-case "`uname`" in
-  CYGWIN* )
-    cygwin=true
-    ;;
-  Darwin* )
-    darwin=true
-    ;;
-  MINGW* )
-    msys=true
-    ;;
-  NONSTOP* )
-    nonstop=true
-    ;;
+case "$( uname )" in                #(
+  CYGWIN* )         cygwin=true  ;; #(
+  Darwin* )         darwin=true  ;; #(
+  MSYS* | MINGW* )  msys=true    ;; #(
+  NONSTOP* )        nonstop=true ;;
 esac
 
 CLASSPATH=$APP_HOME/gradle/wrapper/gradle-wrapper.jar
 
+
 # Determine the Java command to use to start the JVM.
 if [ -n "$JAVA_HOME" ] ; then
     if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
         # IBM's JDK on AIX uses strange locations for the executables
-        JAVACMD="$JAVA_HOME/jre/sh/java"
+        JAVACMD=$JAVA_HOME/jre/sh/java
     else
-        JAVACMD="$JAVA_HOME/bin/java"
+        JAVACMD=$JAVA_HOME/bin/java
     fi
     if [ ! -x "$JAVACMD" ] ; then
         die "ERROR: JAVA_HOME is set to an invalid directory: $JAVA_HOME
@@ -81,7 +132,7 @@ Please set the JAVA_HOME variable in your environment to match the
 location of your Java installation."
     fi
 else
-    JAVACMD="java"
+    JAVACMD=java
     which java >/dev/null 2>&1 || die "ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
 
 Please set the JAVA_HOME variable in your environment to match the
@@ -89,84 +140,105 @@ location of your Java installation."
 fi
 
 # Increase the maximum file descriptors if we can.
-if [ "$cygwin" = "false" -a "$darwin" = "false" -a "$nonstop" = "false" ] ; then
-    MAX_FD_LIMIT=`ulimit -H -n`
-    if [ $? -eq 0 ] ; then
-        if [ "$MAX_FD" = "maximum" -o "$MAX_FD" = "max" ] ; then
-            MAX_FD="$MAX_FD_LIMIT"
-        fi
-        ulimit -n $MAX_FD
-        if [ $? -ne 0 ] ; then
-            warn "Could not set maximum file descriptor limit: $MAX_FD"
-        fi
-    else
-        warn "Could not query maximum file descriptor limit: $MAX_FD_LIMIT"
-    fi
+if ! "$cygwin" && ! "$darwin" && ! "$nonstop" ; then
+    case $MAX_FD in #(
+      max*)
+        # In POSIX sh, ulimit -H is undefined. That's why the result is checked to see if it worked.
+        # shellcheck disable=SC3045 
+        MAX_FD=$( ulimit -H -n ) ||
+            warn "Could not query maximum file descriptor limit"
+    esac
+    case $MAX_FD in  #(
+      '' | soft) :;; #(
+      *)
+        # In POSIX sh, ulimit -n is undefined. That's why the result is checked to see if it worked.
+        # shellcheck disable=SC3045 
+        ulimit -n "$MAX_FD" ||
+            warn "Could not set maximum file descriptor limit to $MAX_FD"
+    esac
 fi
 
-# For Darwin, add options to specify how the application appears in the dock
-if $darwin; then
-    GRADLE_OPTS="$GRADLE_OPTS \"-Xdock:name=$APP_NAME\" \"-Xdock:icon=$APP_HOME/media/gradle.icns\""
-fi
+# Collect all arguments for the java command, stacking in reverse order:
+#   * args from the command line
+#   * the main class name
+#   * -classpath
+#   * -D...appname settings
+#   * --module-path (only if needed)
+#   * DEFAULT_JVM_OPTS, JAVA_OPTS, and GRADLE_OPTS environment variables.
+
+# For Cygwin or MSYS, switch paths to Windows format before running java
+if "$cygwin" || "$msys" ; then
+    APP_HOME=$( cygpath --path --mixed "$APP_HOME" )
+    CLASSPATH=$( cygpath --path --mixed "$CLASSPATH" )
+
+    JAVACMD=$( cygpath --unix "$JAVACMD" )
 
-# For Cygwin, switch paths to Windows format before running java
-if $cygwin ; then
-    APP_HOME=`cygpath --path --mixed "$APP_HOME"`
-    CLASSPATH=`cygpath --path --mixed "$CLASSPATH"`
-    JAVACMD=`cygpath --unix "$JAVACMD"`
-
-    # We build the pattern for arguments to be converted via cygpath
-    ROOTDIRSRAW=`find -L / -maxdepth 1 -mindepth 1 -type d 2>/dev/null`
-    SEP=""
-    for dir in $ROOTDIRSRAW ; do
-        ROOTDIRS="$ROOTDIRS$SEP$dir"
-        SEP="|"
-    done
-    OURCYGPATTERN="(^($ROOTDIRS))"
-    # Add a user-defined pattern to the cygpath arguments
-    if [ "$GRADLE_CYGPATTERN" != "" ] ; then
-        OURCYGPATTERN="$OURCYGPATTERN|($GRADLE_CYGPATTERN)"
-    fi
     # Now convert the arguments - kludge to limit ourselves to /bin/sh
-    i=0
-    for arg in "$@" ; do
-        CHECK=`echo "$arg"|egrep -c "$OURCYGPATTERN" -`
-        CHECK2=`echo "$arg"|egrep -c "^-"`                                 ### Determine if an option
-
-        if [ $CHECK -ne 0 ] && [ $CHECK2 -eq 0 ] ; then                    ### Added a condition
-            eval `echo args$i`=`cygpath --path --ignore --mixed "$arg"`
-        else
-            eval `echo args$i`="\"$arg\""
+    for arg do
+        if
+            case $arg in                                #(
+              -*)   false ;;                            # don't mess with options #(
+              /?*)  t=${arg#/} t=/${t%%/*}              # looks like a POSIX filepath
+                    [ -e "$t" ] ;;                      #(
+              *)    false ;;
+            esac
+        then
+            arg=$( cygpath --path --ignore --mixed "$arg" )
         fi
-        i=$((i+1))
+        # Roll the args list around exactly as many times as the number of
+        # args, so each arg winds up back in the position where it started, but
+        # possibly modified.
+        #
+        # NB: a `for` loop captures its iteration list before it begins, so
+        # changing the positional parameters here affects neither the number of
+        # iterations, nor the values presented in `arg`.
+        shift                   # remove old arg
+        set -- "$@" "$arg"      # push replacement arg
     done
-    case $i in
-        (0) set -- ;;
-        (1) set -- "$args0" ;;
-        (2) set -- "$args0" "$args1" ;;
-        (3) set -- "$args0" "$args1" "$args2" ;;
-        (4) set -- "$args0" "$args1" "$args2" "$args3" ;;
-        (5) set -- "$args0" "$args1" "$args2" "$args3" "$args4" ;;
-        (6) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" ;;
-        (7) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" "$args6" ;;
-        (8) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" "$args6" "$args7" ;;
-        (9) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" "$args6" "$args7" "$args8" ;;
-    esac
 fi
 
-# Escape application args
-save () {
-    for i do printf %s\\n "$i" | sed "s/'/'\\\\''/g;1s/^/'/;\$s/\$/' \\\\/" ; done
-    echo " "
-}
-APP_ARGS=$(save "$@")
-
-# Collect all arguments for the java command, following the shell quoting and substitution rules
-eval set -- $DEFAULT_JVM_OPTS $JAVA_OPTS $GRADLE_OPTS "\"-Dorg.gradle.appname=$APP_BASE_NAME\"" -classpath "\"$CLASSPATH\"" org.gradle.wrapper.GradleWrapperMain "$APP_ARGS"
-
-# by default we should be in the correct project dir, but when run from Finder on Mac, the cwd is wrong
-if [ "$(uname)" = "Darwin" ] && [ "$HOME" = "$PWD" ]; then
-  cd "$(dirname "$0")"
+# Collect all arguments for the java command;
+#   * $DEFAULT_JVM_OPTS, $JAVA_OPTS, and $GRADLE_OPTS can contain fragments of
+#     shell script including quotes and variable substitutions, so put them in
+#     double quotes to make sure that they get re-expanded; and
+#   * put everything else in single quotes, so that it's not re-expanded.
+
+set -- \
+        "-Dorg.gradle.appname=$APP_BASE_NAME" \
+        -classpath "$CLASSPATH" \
+        org.gradle.wrapper.GradleWrapperMain \
+        "$@"
+
+# Stop when "xargs" is not available.
+if ! command -v xargs >/dev/null 2>&1
+then
+    die "xargs is not available"
 fi
 
+# Use "xargs" to parse quoted args.
+#
+# With -n1 it outputs one arg per line, with the quotes and backslashes removed.
+#
+# In Bash we could simply go:
+#
+#   readarray ARGS < <( xargs -n1 <<<"$var" ) &&
+#   set -- "${ARGS[@]}" "$@"
+#
+# but POSIX shell has neither arrays nor command substitution, so instead we
+# post-process each arg (as a line of input to sed) to backslash-escape any
+# character that might be a shell metacharacter, then use eval to reverse
+# that process (while maintaining the separation between arguments), and wrap
+# the whole thing up as a single "set" statement.
+#
+# This will of course break if any of these variables contains a newline or
+# an unmatched quote.
+#
+
+eval "set -- $(
+        printf '%s\n' "$DEFAULT_JVM_OPTS $JAVA_OPTS $GRADLE_OPTS" |
+        xargs -n1 |
+        sed ' s~[^-[:alnum:]+,./:=@_]~\\&~g; ' |
+        tr '\n' ' '
+    )" '"$@"'
+
 exec "$JAVACMD" "$@"
index e95643d6a2ca62258464e83c72f5156dc941c609..6689b85beecde676054c39c2408085f41e6be6dc 100755 (executable)
@@ -1,4 +1,20 @@
-@if "%DEBUG%" == "" @echo off\r
+@rem\r
+@rem Copyright 2015 the original author or authors.\r
+@rem\r
+@rem Licensed under the Apache License, Version 2.0 (the "License");\r
+@rem you may not use this file except in compliance with the License.\r
+@rem You may obtain a copy of the License at\r
+@rem\r
+@rem      https://www.apache.org/licenses/LICENSE-2.0\r
+@rem\r
+@rem Unless required by applicable law or agreed to in writing, software\r
+@rem distributed under the License is distributed on an "AS IS" BASIS,\r
+@rem WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\r
+@rem See the License for the specific language governing permissions and\r
+@rem limitations under the License.\r
+@rem\r
+\r
+@if "%DEBUG%"=="" @echo off\r
 @rem ##########################################################################\r
 @rem\r
 @rem  Gradle startup script for Windows\r
 if "%OS%"=="Windows_NT" setlocal\r
 \r
 set DIRNAME=%~dp0\r
-if "%DIRNAME%" == "" set DIRNAME=.\r
+if "%DIRNAME%"=="" set DIRNAME=.\r
+@rem This is normally unused\r
 set APP_BASE_NAME=%~n0\r
 set APP_HOME=%DIRNAME%\r
 \r
+@rem Resolve any "." and ".." in APP_HOME to make it shorter.\r
+for %%i in ("%APP_HOME%") do set APP_HOME=%%~fi\r
+\r
 @rem Add default JVM options here. You can also use JAVA_OPTS and GRADLE_OPTS to pass JVM options to this script.\r
-set DEFAULT_JVM_OPTS=\r
+set DEFAULT_JVM_OPTS="-Xmx64m" "-Xms64m"\r
 \r
 @rem Find java.exe\r
 if defined JAVA_HOME goto findJavaFromJavaHome\r
 \r
 set JAVA_EXE=java.exe\r
 %JAVA_EXE% -version >NUL 2>&1\r
-if "%ERRORLEVEL%" == "0" goto init\r
+if %ERRORLEVEL% equ 0 goto execute\r
 \r
 echo.\r
 echo ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.\r
@@ -35,7 +55,7 @@ goto fail
 set JAVA_HOME=%JAVA_HOME:"=%\r
 set JAVA_EXE=%JAVA_HOME%/bin/java.exe\r
 \r
-if exist "%JAVA_EXE%" goto init\r
+if exist "%JAVA_EXE%" goto execute\r
 \r
 echo.\r
 echo ERROR: JAVA_HOME is set to an invalid directory: %JAVA_HOME%\r
@@ -45,38 +65,26 @@ echo location of your Java installation.
 \r
 goto fail\r
 \r
-:init\r
-@rem Get command-line arguments, handling Windows variants\r
-\r
-if not "%OS%" == "Windows_NT" goto win9xME_args\r
-\r
-:win9xME_args\r
-@rem Slurp the command line arguments.\r
-set CMD_LINE_ARGS=\r
-set _SKIP=2\r
-\r
-:win9xME_args_slurp\r
-if "x%~1" == "x" goto execute\r
-\r
-set CMD_LINE_ARGS=%*\r
-\r
 :execute\r
 @rem Setup the command line\r
 \r
 set CLASSPATH=%APP_HOME%\gradle\wrapper\gradle-wrapper.jar\r
 \r
+\r
 @rem Execute Gradle\r
-"%JAVA_EXE%" %DEFAULT_JVM_OPTS% %JAVA_OPTS% %GRADLE_OPTS% "-Dorg.gradle.appname=%APP_BASE_NAME%" -classpath "%CLASSPATH%" org.gradle.wrapper.GradleWrapperMain %CMD_LINE_ARGS%\r
+"%JAVA_EXE%" %DEFAULT_JVM_OPTS% %JAVA_OPTS% %GRADLE_OPTS% "-Dorg.gradle.appname=%APP_BASE_NAME%" -classpath "%CLASSPATH%" org.gradle.wrapper.GradleWrapperMain %*\r
 \r
 :end\r
 @rem End local scope for the variables with windows NT shell\r
-if "%ERRORLEVEL%"=="0" goto mainEnd\r
+if %ERRORLEVEL% equ 0 goto mainEnd\r
 \r
 :fail\r
 rem Set variable GRADLE_EXIT_CONSOLE if you need the _script_ return code instead of\r
 rem the _cmd.exe /c_ return code!\r
-if  not "" == "%GRADLE_EXIT_CONSOLE%" exit 1\r
-exit /b 1\r
+set EXIT_CODE=%ERRORLEVEL%\r
+if %EXIT_CODE% equ 0 set EXIT_CODE=1\r
+if not ""=="%GRADLE_EXIT_CONSOLE%" exit %EXIT_CODE%\r
+exit /b %EXIT_CODE%\r
 \r
 :mainEnd\r
 if "%OS%"=="Windows_NT" endlocal\r